#|
This file is part of Ordo.

Copyright (C) 2025 Ray Miller

This program is free software: you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation, version 3.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
this program. If not, see <https://www.gnu.org/licenses/>.
|#

(define-module (ordo task)
  #:use-module (ordo logger)
  #:use-module (srfi srfi-9)
  #:export (task
            task?
            task-name
            task-pre-condition
            task-action
            run-task))

(define-record-type <task>
  (make-task name action pre-condition)
  task?
  (name task-name)
  (pre-condition task-pre-condition)
  (action task-action))

(define* (task #:key name action (pre-condition (const #t)))
  (make-task name action pre-condition))

(define (run-task t conn)
  (if ((task-pre-condition t) conn)
      (begin
        (log-msg 'NOTICE "Running task " (task-name t))
        ((task-action t) conn))
      (log-msg 'NOTICE "Skipping task " (task-name t) ": pre-condition not met")))
